package Library;

import java.util.Vector;

public class Definitions {

    //Final Variables
    public static final int    GRID_WIDTH             = 5;
    public static final int    GRID_HEIGHT            = 13;
    public static final int    X_INTERVAl             = GRID_WIDTH+1;
    public static final int    Y_INTERVAl             = GRID_HEIGHT;
    public static final int    NUMBER_OF_ITERATIONS   = 10000;
    public static final double LEARNING_RATE          = 0.1;
    public static final double LAMBDA                 = 1;
    public static final int    NUM_OF_INPUT_NEURONS   = GRID_WIDTH*GRID_HEIGHT;
    public static final int    NUM_OF_OUTPUT_NEURONS  = 11;
    public static final int    NUM_OF_HIDDEN1_NEURONS = 8;
    public static final int    NUM_OF_HIDDEN2_NEURONS = 8;
    public static final int    NUM_OF_SAMPLES         = 11;
    public static final int    BLANK_TAB              = 10;

    //Functions
    public static double sigmoid(double x){
        return 1.0/(1.0 + Math.exp(-LAMBDA*x));
    }

    public static Vector BinaryArrayToVector(int[] arr){
      Vector ans = new Vector();
      for (int i = 0 ; i < arr.length ; ++i){
        ans.addElement(NumberFactory.getDouble0(arr[i]));
      }
      return ans;
    }

    public static int maxElementIndexInVector(Vector vec){
        double max = ((Double)vec.elementAt(0)).doubleValue();
        int index  = 0;
        for (int i = 1 ; i < vec.size() ; ++i){
            double val = ((Double)vec.elementAt(i)).doubleValue();
            if (val > max){
                max     = val;
                index   = i;
            }
        }
        return index;
    }
}






