package Data;

import javax.imageio.ImageIO;
import java.util.Vector;
import java.io.File;
import java.io.IOException;
import java.awt.image.BufferedImage;


public class ReadImg {
    public static Vector getVectorInput(String fileName){
       Vector inputVector = new Vector();
       BufferedImage img = null;
       try{
            img = ImageIO.read(new File(fileName));
       }
       catch (IOException e) {

       }
       for (int  y = 0 ; y < img.getHeight() ; ++y){
            for (int x = 0 ; x < img.getWidth() ; ++x){
                int pixelColor = img.getRGB(x,y);
                pixelColor     = normalize(pixelColor);
                inputVector.addElement(new Double(pixelColor));
            }
       }
       return inputVector;
    }

    public static Vector getVectorInput(BufferedImage img,int xOffset,int yOffset){
        Vector inputVector = new Vector();
        for (int  y = 0 ; y < Library.Definitions.GRID_HEIGHT ; ++y){
            for (int x = 0 ; x < Library.Definitions.GRID_WIDTH ; ++x){
                int pixelColor = img.getRGB(x+xOffset,y+yOffset);
                pixelColor     = normalize(pixelColor);
                inputVector.addElement(new Double(pixelColor));
            }
        }
        return inputVector;
    }
    private static int normalize(int pixel){
        if (pixel == -16777216)
            return 1;
        else
            return 0;
    }
}