package Domain;


public class Synapse {

  private double m_weight;
  private double m_data; //for momentum,don't use
  private Neuron m_from;
  private Neuron m_to;

 public Synapse(Neuron f,Neuron t){
      m_from   = f;
      m_to     = t;
      m_weight = Math.random()*2 -1 ;
      m_data   = 0.0;
      f.addOutputSynapse(this);
      t.addInputSynapse(this);
 }

 public double getData(){
    return m_data;
 }

 public Neuron getFromNeuron(){
    return m_from;
 }

 public Neuron getToNeuron(){
    return m_to;
 }

 public double getWeight(){
    return m_weight;
 }

 public void setWeight(double weight) {
    m_weight = weight;
 }

 public void setData(double data) {
    m_data = data;
 }
}
