package Sound;

import java.util.Vector;

public class TabsToNotes{
    private static final int[] GUITAR_STRING_OFFSET ={76,71,67,50,33,28};

    public static int getNote(int tab,int stringNumber){
        if (tab == Library.Definitions.BLANK_TAB)
            return -1;
        else
            return tab+GUITAR_STRING_OFFSET[stringNumber-1];
    }

    public static int[] getNotesArr(Vector tabsVector,int stringNumber){
        int[] notesArr = new int[tabsVector.size()];
        for (int i = 0 ; i < tabsVector.size() ; ++i){
            int tab =((Integer)tabsVector.elementAt(i)).intValue();
            notesArr[i] = getNote(tab,stringNumber);
        }
        return notesArr;
    }
}

